public class Robot {
   private Robot() { 
      this(new Vector2D(), new Vector2D(), 0, null);
   }
   public Robot(Vector2D position, Vector2D velocity, double sensorRange, MyWorld w) {
      pos = position;
      v = velocity;
      world = w;
      Vector2D dir = v.getUnitary();
      rightSensor = new DistanceSensor(new Vector2D(dir.getY(), -dir.getX()), sensorRange);
      frontSensor = new DistanceSensor(dir, sensorRange);
      leftSensor = new DistanceSensor(new Vector2D(-dir.getY(), dir.getX()), sensorRange);
      // It might need more code
   }
   public Vector2D getPosition() {
      return pos;
   }
   public Vector2D getVelocity() {
      return v;
   }
   public void turnLeft(){
      v.turnLeft();
      rightSensor.turnLeft();
      frontSensor.turnLeft();
      leftSensor.turnLeft();
//      System.out.println("turning left...");  // for debugging
      return; 
   }
   public void turnRight(){
      v.turnRight();
      rightSensor.turnRight();
      frontSensor.turnRight();
      leftSensor.turnRight();      
   //  System.out.println("turning right...");
      return; 
   }
   public void moveDelta_t(double delta_t) {
   // here is where you could turn depending on the sensors info
      pos = pos.plus(v.times(delta_t));      
   }
   public String getDescription() {
      return pos.getDescription();
   }
   public String toString() {
      return pos.toString()+ rightSensor.toString() + frontSensor.toString()+leftSensor.toString();
   }
   public void markRoute(Maze m){
      // to be coded
   }
   private class DistanceSensor { // only used in Robot, therefore it is an internal class.
      public DistanceSensor(Vector2D direction, double rang) {
         dir = direction;
         range = rang;
      }
      public void turnLeft(){
         dir.turnLeft();
      }
      public void turnRight() {
         dir.turnRight();
      }
      public boolean senseWall(){
      // to be coded
      }
      public String toString() {
         return " "+senseWall();
      }
      
      private Vector2D dir;  // orientation direction with respect to forward robot's direction
      private double range;
      private static final double presition = 0.4;
   }
      
   private Vector2D pos;
   private Vector2D v;
   private MyWorld world;
   private DistanceSensor rightSensor, frontSensor, leftSensor;
   private boolean lookingForRightWall; // used to find right wall when left sensor does not detects it
}